import {
  actions_default
} from "./chunk-NNADGHSL.js";
import {
  usersSlice_default
} from "./chunk-YGBFDXXA.js";
import {
  releasesSlice_default
} from "./chunk-CYV6632F.js";
import {
  deploymentsSlice_default
} from "./chunk-E5LEU5PF.js";
import {
  onboardingSlice_default
} from "./chunk-FGKMJS3B.js";
import {
  actions,
  organizationSlice_default
} from "./chunk-XTRPX7JZ.js";
import {
  devicesSlice_default
} from "./chunk-YTQUNAZP.js";
import {
  monitorSlice_default
} from "./chunk-UEP36GCI.js";
import {
  appSlice_default
} from "./chunk-7PVGDMNM.js";
import {
  getToken
} from "./chunk-AMGWP7A4.js";
import {
  USER_LOGOUT,
  settingsKeys
} from "./chunk-A6CT6GTI.js";

// src/store.ts
import { extractErrorMessage, preformatWithRequestID } from "@northern.tech/utils/helpers";
import { combineReducers, configureStore } from "@reduxjs/toolkit";
var { setSnackbar, uploadProgress } = actions_default;
var keys = ["sessionDeploymentChecker", settingsKeys.initialized];
var resetEnvironment = () => {
  keys.map((key) => window.sessionStorage.removeItem(key));
};
resetEnvironment();
var commonErrorFallback = "Please check your connection.";
var commonErrorHandler = (err, errorContext, dispatch, fallback, mightBeAuthRelated = false) => {
  const errMsg = extractErrorMessage(err, fallback);
  if (mightBeAuthRelated || getToken()) {
    dispatch(setSnackbar({ message: preformatWithRequestID(err.response, `${errorContext} ${errMsg}`), action: "Copy to clipboard" }));
  }
  return Promise.reject(err);
};
var rootReducer = combineReducers({
  app: appSlice_default,
  devices: devicesSlice_default,
  deployments: deploymentsSlice_default,
  monitor: monitorSlice_default,
  onboarding: onboardingSlice_default,
  organization: organizationSlice_default,
  releases: releasesSlice_default,
  users: usersSlice_default
});
var sessionReducer = (state, action) => {
  if (action.type === USER_LOGOUT) {
    state = void 0;
  }
  return rootReducer(state, action);
};
var getConfiguredStore = (options = {}) => {
  const { preloadedState = {}, ...config } = options;
  return configureStore({
    ...config,
    preloadedState,
    reducer: sessionReducer,
    middleware: (getDefaultMiddleware) => getDefaultMiddleware({
      immutableCheck: {
        ignoredPaths: ["app.uploadsById"]
      },
      serializableCheck: {
        ignoredActions: [actions.receiveExternalDeviceIntegrations.name, setSnackbar.name, uploadProgress.name],
        ignoredActionPaths: ["uploads", "snackbar", /payload\..*$/],
        ignoredPaths: ["app.uploadsById", "app.snackbar", "organization.externalDeviceIntegrations"]
      }
    })
  });
};
var store = getConfiguredStore({
  preloadedState: {}
});

export {
  commonErrorFallback,
  commonErrorHandler,
  sessionReducer,
  getConfiguredStore,
  store
};
//# sourceMappingURL=chunk-2RJIDREZ.js.map