import * as axios from 'axios';
import * as _reduxjs_toolkit from '@reduxjs/toolkit';
import * as redux_thunk from 'redux-thunk';
import * as redux from 'redux';

declare const loginUser: _reduxjs_toolkit.AsyncThunk<any, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const logoutUser: _reduxjs_toolkit.AsyncThunk<axios.AxiosResponse<any, any>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const switchUserOrganization: _reduxjs_toolkit.AsyncThunk<void, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const passwordResetStart: _reduxjs_toolkit.AsyncThunk<axios.AxiosResponse<any, any>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const passwordResetComplete: _reduxjs_toolkit.AsyncThunk<axios.AxiosResponse<any, any>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const verifyEmailStart: _reduxjs_toolkit.AsyncThunk<axios.AxiosResponse<any, any>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const verifyEmailComplete: _reduxjs_toolkit.AsyncThunk<axios.AxiosResponse<any, any>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const verify2FA: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<[{
    payload: any;
    type: "users/receivedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/setCustomColumns";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getUserList: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/receivedUserList";
}, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getUser: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/receivedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/setCustomColumns";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const initializeSelf: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<[{
    payload: any;
    type: "users/receivedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/setCustomColumns";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const updateUserColumnSettings: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/setCustomColumns";
}, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const createUser: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/createdUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/receivedUserList";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const removeUser: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/removedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/receivedUserList";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const editUser: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/updatedUser";
}, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const addUserToCurrentTenant: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "app/setSnackbar";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/receivedUserList";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const enableUser2fa: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<[{
    payload: any;
    type: "users/receivedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/setCustomColumns";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const disableUser2fa: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<[{
    payload: any;
    type: "users/receivedUser";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/setCustomColumns";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const normalizeRbacRoles: (roles: any, rolesById: any, permissionSets: any) => any;
declare const getPermissionSets: _reduxjs_toolkit.AsyncThunk<void | [{
    payload: any;
    type: "users/receivedPermissionSets";
}, any], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getRoles: _reduxjs_toolkit.AsyncThunk<void | [axios.AxiosResponse<any, any>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [{
    payload: any;
    type: "users/receivedPermissionSets";
}, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const createRole: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/createdRole";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [axios.AxiosResponse<any, any>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [{
    payload: any;
    type: "users/receivedPermissionSets";
}, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const editRole: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/createdRole";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [axios.AxiosResponse<any, any>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [{
    payload: any;
    type: "users/receivedPermissionSets";
}, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const removeRole: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/removedRole";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [axios.AxiosResponse<any, any>, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<void | [{
    payload: any;
    type: "users/receivedPermissionSets";
}, any], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>], string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, {
    payload: any;
    type: "app/setSnackbar";
}], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getGlobalSettings: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/setGlobalSettings";
}, _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const saveGlobalSettings: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/setGlobalSettings";
}[] | [{
    payload: any;
    type: "users/setGlobalSettings";
}[]] | undefined, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getUserSettings: _reduxjs_toolkit.AsyncThunk<[{
    payload: any;
    type: "users/setUserSettings";
}, any], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const saveUserSettings: _reduxjs_toolkit.AsyncThunk<unknown, void | undefined, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction> | undefined;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const get2FAQRCode: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/receivedQrCode";
}, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const setHideAnnouncement: _reduxjs_toolkit.AsyncThunk<unknown, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const getTokens: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/updatedUser";
}, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const generateToken: _reduxjs_toolkit.AsyncThunk<[_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/updatedUser";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, any], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const revokeToken: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError> | _reduxjs_toolkit.PayloadAction<{
    payload: any;
    type: "users/updatedUser";
}, string, {
    arg: void;
    requestId: string;
    requestStatus: "fulfilled";
}, never>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const setTooltipReadState: _reduxjs_toolkit.AsyncThunk<{
    payload: any;
    type: "users/setTooltipState";
}[], void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
declare const setAllTooltipsReadState: _reduxjs_toolkit.AsyncThunk<_reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void | undefined;
    requestId: string;
    requestStatus: "fulfilled";
}, never> | _reduxjs_toolkit.PayloadAction<unknown, string, {
    arg: void | undefined;
    requestId: string;
    requestStatus: "rejected";
    aborted: boolean;
    condition: boolean;
} & ({
    rejectedWithValue: true;
} | ({
    rejectedWithValue: false;
} & {})), _reduxjs_toolkit.SerializedError>, void, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;
interface SubmitFeedbackPayload {
    satisfaction: string;
    feedback: string;
    meta?: Record<string, unknown>;
}
declare const submitFeedback: _reduxjs_toolkit.AsyncThunk<SubmitFeedbackPayload, SubmitFeedbackPayload, {
    state?: unknown;
    dispatch?: redux_thunk.ThunkDispatch<unknown, unknown, redux.UnknownAction>;
    extra?: unknown;
    rejectValue?: unknown;
    serializedErrorType?: unknown;
    pendingMeta?: unknown;
    fulfilledMeta?: unknown;
    rejectedMeta?: unknown;
}>;

export { addUserToCurrentTenant, createRole, createUser, disableUser2fa, editRole, editUser, enableUser2fa, generateToken, get2FAQRCode, getGlobalSettings, getPermissionSets, getRoles, getTokens, getUser, getUserList, getUserSettings, initializeSelf, loginUser, logoutUser, normalizeRbacRoles, passwordResetComplete, passwordResetStart, removeRole, removeUser, revokeToken, saveGlobalSettings, saveUserSettings, setAllTooltipsReadState, setHideAnnouncement, setTooltipReadState, submitFeedback, switchUserOrganization, updateUserColumnSettings, verify2FA, verifyEmailComplete, verifyEmailStart };
